<?php
/*  Program name: checkAll.php
 *  Description:  Program checks all the form fields for
 *                blank fields and incorrect format.
 */
?>
<html>
<head><title>Check fields</title></head>
<body>
<?php
  /* set up array containing all the fields */
  $labels = array ( "first_name" => "First Name",
                    "middle_name" => "Middle Name",
                    "last_name" => "Last Name",
                    "phone" => "Phone");
  foreach ($_POST as $field => $value)
  {
    /* check each field except middle name for blank fields */
    if ( $value == "" )
    {
       if ($field != "middle_name")
       {
          $blank_array[] = $field;
       }
    }
    /* check names for invalid formats. */
    elseif ($field == "first_name" or $field == "middle_name" 
                 or $field == "last_name" )
    {
        if (!ereg("^[A-Za-z' -]{1,50}$",$_POST[$field]) )
        {
             $bad_format[] = $field;
        }
    }
    /* check phone for invalid format. */
    elseif ($field == "phone")
    {
      if(!ereg("^[0-9)( -]{7,20}(([xX]|(ext)|(ex))?[ -]?[0-9]{1,7})?$"
	       ,$value))
      {
           $bad_format[] = $field;
      }
    }
  }
  /* if any fields are not okay, display error message and form */
  if(@sizeof($blank_array) > 0 or @sizeof($bad_format) > 0)
  {
    if(@sizeof($blank_array) > 0)
    {
        /* display message for missing information */
        echo "<b>You didn't fill in one or more required 
		         fields. You must enter:</b><br>";
        /* display list of missing information */
        foreach($blank_array as $value)
        {
           echo "&nbsp;&nbsp;&nbsp;{$labels[$value]}<br>";
        }
    }
    if(@sizeof($bad_format) > 0)
    {
        /* display message for bad information */
        echo "<b>One or more fields have information that appears to be 
                 incorrect. Correct the format for:</b><br>";
        /* display list of bad information */
        foreach($bad_format as $value)
        {
           echo "&nbsp;&nbsp;&nbsp;{$labels[$value]}<br>";
        }
    }
    /* redisplay form */
    echo "<p>";
	echo "<form action='$_SERVER[PHP_SELF]' method='POST'>
          <table>";
    foreach($labels as $field => $label)
    {
      $good_data[$field]=strip_tags(trim($_POST[$field]));
      echo "<tr>
             <td style='text-align: right; font-weight: bold'>
	  	        {$labels[$field]}</td>
             <td><input type='text' name='$field' size='65'
                 maxlength='65' value='$good_data[$field]'></td>
            </tr>";
    }
    echo "<tr>
           <td colspan='2' style='text-align: center'>
             <input type='submit' value='Submit Name and Phone Number'>";
    echo "</td></tr></table>
          </form>";
    exit();
  }
  /* if data is good */
  echo "All data is good";
?>
</body></html>
