<?php
/*  Program name: savePhone.php
 *  Description:  Program checks all the form fields for
 *                blank fields and incorrect format. Saves the
 *                correct fields in a database.
 */
?>
<html>
<head><title>Member Phone Number</title></head>
<body>
<?php
  /* set up array of field labels */
  $labels = array( "first_name" => "First Name",
                   "last_name" => "Last Name",
                   "phone" => "Phone");
/* Check information from form */
  foreach($_POST as $field => $value)
  {
    /* check each field for blank fields */
    if( $value == "" )
    {
      $blank_array[] = $field;
    }
	/* check format of each field */
    elseif( ereg("(name)",$field) )  
    {
      if(!ereg("^[A-Za-z' -]{1,50}$",$value) )
      {
          $bad_format[] = $field;
      }
    }
    elseif($field == "phone")
    {
      if(!ereg("^[0-9)( -]{7,20}(([xX]|(ext)|(ex))?[ -]?[0-9]{1,7})?$",$value) )
      {
          $bad_format[] = $field;
      }
    }
  } // end of foreach for $_POST
  /* if any fields were not okay, display error message and form */
  if(@sizeof($blank_array) > 0 or @sizeof($bad_format) > 0)
  {
    if(@sizeof($blank_array) > 0)
    {
        /* display message for missing information */
        echo "<b>You didn't fill in one or more required fields. 
                 You must enter:</b><br>";
        /* display list of missing information */
        foreach($blank_array as $value)
        {
           echo "&nbsp;&nbsp;&nbsp;{$labels[$value]}<br>";
        }
    }
    if(@sizeof($bad_format) > 0)
    {
        /* display message for bad information */
        echo "<b>One or more fields have information that appears to 
                 be incorrect. Correct the format for:</b><br>";
        /* display list of bad information */
        foreach($bad_format as $value)
        {
           echo "&nbsp;&nbsp;&nbsp;{$labels[$value]}<br>";
        }
    }
    /* redisplay form */
    echo "<p><hr />";
    echo "<h3>Please enter your phone number below.</h3>";
    echo "<form action='savePhone.php' method='POST'>
          <table>";
    foreach($labels as $field => $label)
    {
      $good_data[$field]=strip_tags(trim($_POST[$field]));
      echo "<tr>
             <td style='text-align: right; font-weight: bold'>
	  	        $label</td>
             <td><input type='text' name='$field' size='65'
                 maxlength='65' value='$good_data[$field]'></td>
            </tr>";
    }
    echo "<tr>
           <td colspan='2' style='text-align: center'>
              <input type='submit' value='Submit Phone Number'>";
    echo "</td></tr></table>
          </form>";
    exit();
  }
else   //if data is okay
  {
    $user="admin";
    $host="localhost";
    $password="";
    $database = "MemberDirectory";
    $cxn = mysqli_connect($host,$user,$password,$database)
           or die ("couldn't connect to server");
    if(storeForm($_POST,"phone",$cxn))
	{
        echo "New Member added to database<br>";
    }
	else
	{
	    echo "New Member was not added to the database<br>";
    }
  }
  
function storeForm($formdata,$tablename,$cxn)
{
   if (!is_array($formdata))
   {
     return FALSE;
     exit();
   }
   foreach ($formdata as $field => $value)
   {
      $formdata[$field] = trim($formdata[$field]);
      $formdata[$field] = strip_tags($formdata[$field]);
      if ($field == "phone")
      { 
          $formdata[$field] = 
             ereg_replace("[)( .-]","",$formdata[$field]);
      }
      $field_array[]=$field;
      $value_array[]=$formdata[$field];
   }
   $fields=implode(",",$field_array);
   $values=implode('","',$value_array);
   $query = "INSERT INTO $tablename ($fields) 
                    VALUES (\"$values\")";
					echo $query;
   if($result = mysqli_query($cxn,$query))
      return TRUE;
   else
      return FALSE;
}

?>
</body></html>
